#!/bin/sh
#
# File:		daswd.sh
#
# Description:	Shell Script
# Author:	IBM Corp.
#
# (C) COPYRIGHT IBM Corp.,  2005
# All Rights Reserved
# Licensed Material - Property of IBM Corp.
#

# Usage statement
if [ $# -lt 5 ] ; then
        echo "Usage: $0 <CurrentHostName> <policy-region> <Source Path> <Target Path> <xml File> [SWD Version]"
        exit 1
fi
PROGNAME=`echo $0 | sed -e 's.\\\\./.g'`
PROGNAME=`basename $PROGNAME`
echo "*** Executing $PROGNAME"

chostname=$1
pregion=$2
sourcep=$3
targetp=$4
xmlfile=$5
swdver=$6

ver="swd.src"
   if [ "$swdver" = "4.0" ] ; then
      ver="swd40.src"
   fi


#parse xml file for values

function getxmlvalue 
{
     xmlarg="$@"
     xmlval1=${xmlarg##*<VALUE>}
     xmlvalue=${xmlval1%%</VALUE>*}
}

function parseicl 
{
     icl="$@"
     uim_args=${icl##*.exe}
     uim_program=${icl%% *}
}

#Get package name, second instance
tempval=`grep -A 99 "IBMPSG_SystemUpdateElement" $xmlfile | grep '"Name"'`

getxmlvalue ${tempval}

uim_name=${xmlvalue}

#Get version, first instance
tempval=`grep -A 8 "IBMPSG_SystemUpdateProduct" $xmlfile | grep '"Version"' `

getxmlvalue ${tempval}

uim_version=${xmlvalue}

#Get install command-line
tempval=`grep '"unattendedInstallCommandLine"' $xmlfile`

getxmlvalue ${tempval}

uim_commandline=${xmlvalue}

#get program and args from command line

parseicl ${uim_commandline}

#Get install directory
tempval=`grep '"installDirectory"' $xmlfile`

getxmlvalue ${tempval}

uim_installdir=${xmlvalue}

echo "Package for $uim_name version $uim_version"

sed -e "s?<uim_name>?${uim_name}?g" -e "s?<uim_version>?${uim_version}?g" -e "s?<uim_commandline>?${uim_commandline}?g"  -e "s?<sourcep>?${sourcep}?g" -e "s?<targetp>?${targetp}?g" -e "s?<uim_args>?${uim_args}?g" -e "s?<uim_program>?${uim_program}?g" < $ver >"${uim_name}".spd

wcrtprfmgr $pregion DIRECTOR_SWD
wsetpm -d @ProfileManager:DIRECTOR_SWD

dir=$("pwd")
wimpspo -c @DIRECTOR_SWD -h $chostname -f $dir/"${uim_name}".spd -t build -p $dir/"${uim_name}".spb "${uim_name}"^${uim_version}

exit 0
